Ubuntu

Partition Table is cleared during install on Intel Macs

Reported by Ricky Campbell on 2008-04-25
64
This bug affects 8 people
Affects Status Importance Assigned to Milestone
Mactel Support
Critical
Unassigned
grub-installer
Invalid
Undecided
Unassigned
parted (Ubuntu)
High
Colin Watson
Hardy
High
Colin Watson
Intrepid
High
Colin Watson
Jaunty
High
Colin Watson
ubiquity (Ubuntu)
Undecided
Unassigned
Hardy
Undecided
Unassigned
Intrepid
Undecided
Unassigned
Jaunty
Undecided
Unassigned

Bug Description

Binary package hint: ubiquity

Ubuntu 8.04 Final

Intel Macs have an EFI system and a GPT. The installer seems to handle the GPT correctly (as it has in the past), but it has recently come up that the installer is completely emptying the contents of the MBR partition table which is still required to boot Windows and Ubuntu (GRUB relies on the MBR partition table). The two tables are not synced automatically.

When users install Hardy, they are suprised to find that the system is unbootable (the EFI loader cannot "see" the partition as bootable). a tool such as rEFIt or gptsync can copy the information in the GPT into the MBR table thus fixing the issue (for most).

This is even more serious for users with other working OS installs in addition to Ubuntu (such as other linux distros and Windows) since it completely dumps the information needed to boot these installs as well.

The expected procedure (and how the previous Ubuntu install seems to have handled it) is to 'update' both the GPT and the MBR table with changes instead of completely losing the information stored there.

gparted / parted seemed to update both tables properly previously as well.

I will be doing a full install on my iMac later and will be able to add additional information.

This bug was fixed in parted 1.8.8.git.2008.03.24-11.1ubuntu6 by adding "Apple Inc." as an additional system-manufacturer tag for which we do the special Apple GPT->MBR handling. Here are patches for hardy-proposed and intrepid-proposed:

  http://launchpadlibrarian.net/27503646/hardy.diff
  http://launchpadlibrarian.net/27504724/intrepid.diff

TEST CASE: You'll need a reasonably new Intel-based Mac system for which 'sudo dmidecode -s system-manufacturer' returns "Apple Inc." (not "Apple Computer, Inc."). Check that installations work, and that 'sudo fdisk -l' shows a reasonable MBR representation of the first four partitions on your disk (compare against 'sudo parted -s /dev/sda print').

REGRESSION POTENTIAL: The only other systems that really care about this kind of thing are ones for which 'sudo dmidecode -s system-manufacturer' returns "Apple Computer, Inc."; installations on those systems should keep working. Other than that I think we're basically taking a completely broken case and rendering it at least vaguely functional ...

Ricky Campbell (cyberdork33) wrote :
Changed in mactel-support:
importance: Undecided → High
status: New → Confirmed
Ricky Campbell (cyberdork33) wrote :

i did not experience these problems on my reinstall, but it seems to be because of the method I used to install. We are still trying to determine exactly what causes it.

mabovo (mabovo) wrote :

I resolved to make a clean install on my mackbook 2nd gen and proceed as before but at the end the result was a washed up mbr partition and a message on top of the screen "no bootable device" after selecting ubuntu logo in the rEFI bootloader.

I tried to recover with live CD updating grub but hal package is reported as broken and process return a error

mabovo (mabovo) wrote :

I made in my installation /dev/sda1 rEFIT; /dev/sda2 HFS+; /dev/sda3 ext3 /home; /dev/sda4 ext3 as mount point / and /dev/sda5 as swap.
Problem is that rEFIT recognizes first linux partition as the bootable sector and there is no option to change it in the rEFIT menu tools.

Ricky Campbell (cyberdork33) wrote :

Let's keep this bug on topic. This has nothing to do with rEFIt.

Changed in parted:
status: New → Confirmed
theOlster (oliver-thelortons) wrote :

I too suffered from this problem when attempting to set up a triple-book of MacOSX, Ubuntu & Win XP.

I was only able to get it working after following these guidelines: http://ubuntuforums.org/showthread.php?t=767677&highlight=triple+boot+mac

i confirm: install hardy on a macbook2,1 gives "no bootable device".

i can confirm this on a macbook (generation MB403LL/A). it forced me to format the harddrive and go for a single linux boot.

Ricky Campbell (cyberdork33) wrote :

The install is actually fine, but you have to recreate the MBR partition table, and maybe reinstall grub. The link posted by "theOlster" shows you an easy way to fix it.

Changed in mactel-support:
importance: High → Critical

thanks. I admit I knew there exist some way to fix it, but I was looking for a good reason to get rid of macos ;-)
However, this bug looks quite important to me, as fixing MBT partition issue should not generally required to end users. And (unfortunately, as it is a completely closed platform) macbook users represent a larger and larger share percentage of the total number of computer users. I am surprised that it has not been addressed. I am afraid I am not able to do anything about this.

nevermind, just released it has been labelled as critical. I had looked at the wrong place, as thought it still hang as undecided.

Ricky Campbell (cyberdork33) wrote :

It isn't marked as critical against anything in Ubuntu yet.

Steve Doty (doty) wrote :

This bug has just affected me as well - brand new MacBook Pro 4,1 attempting to install dual book with Hardy.

I'm dismayed at the difficulty here - thought Ubuntu was supposed to "just work".

Chadversary (chadversary) wrote :

If any bug is to be marked critical, it is the failure of the OS to boot.
The Ubuntu installation erased the MBR table, then when attempting to boot Ubuntu GRUB gave the error "no bootable devices". In order to get things working again, I had to sync the MBR table to the GPT using rEFIt, then reinstall GRUB manually.

Peder (peder-moller) wrote :

I had the "no bootable disk" problem on Windows and Ubuntu after installing on my MacBook Pro, (Penryn) in the following order: OSX, Windows XP (using bootcamp), rEFIt, Ubuntu 8.04. When I synchronized the MBR with the rEFIt, Ubuntu started working but windows said that it couldn't find "<windows root>\system32\hal.dll"
I then reinstalled _everything_ (what a pain that OSX can't reformat FAT32 and Swap partitions made by Ubuntu, and that bootcamp can't run unless everything is one big OSX partition), but with rEFIt last with exactly the same result. Reading this thread, I guess this isn't surprising :(
And now I'm no longer baffled by the smoothness with which I installed 7.10 previously...
I hope some of you geniuses will find a neat workaround, but until then I'll try to find a messy one...

Ricky Campbell (cyberdork33) wrote :

Peder,
Please post in the Apple Users Forum and there are several people that can help you. Your problem is not really related to this bug, but rather is an issue with windows.

Ricky,

Sorry for posting in the wrong thread. Not convinced it's a windows
problem though, since replacing hal.dll does not help. Anyways, since
I can see from several threads that you are an expert on this topic, I
would like to ask you _one_ question (if this is inappropriate, please
ignore it and forgive my pretension): Since this is not a problem with
gutsy, will I get a clean install if I triple-boot OSX, XP, and 7.1,
and then upgrade to 8.04?

Whether you answer or not, I owe you people a lot !

All the best,
Peder

On Wed, Jul 23, 2008 at 10:48 PM, Ricky Campbell <email address hidden> wrote:
> Peder,
> Please post in the Apple Users Forum and there are several people that can help you. Your problem is not really related to this bug, but rather is an issue with windows.
>
> --
> MBR Partition Table is cleared during install
> https://bugs.launchpad.net/bugs/222126
> You received this bug notification because you are a direct subscriber
> of the bug.
>

--
Laboratoire de Physique Statistique,
Ecole Normale Supérieure
24, rue Lhomond
75231 Paris Cedex 05
France
Phone(work/home/mobile):
+33 (0)1 4432 2503 / +33 (0)9 5482 1242 / +45 6089 4245
PENGUIN POWER !!

It is not related to MBR but where GRUB is installed in wich partition.
My MacBook is back to the hells again now on Hardy 8.0.4.1.
GRUB and MacBook with REFIT are incompatibles for some reasons.
I have tried all sugestions on How to recover GRUB even in the GRUB manual, update-grub, grub-install, set (hd,0), find /boot/grub/stage1, reinstalled GRUB, installed "LILO", reinstalled UBUNTU 8.0.4.1 removing all conflicting files, updated last linux kernel, after all that, I get one more "penguim" on REFIT menu.

mabovo (mabovo) wrote :

Just to complement my last post....
I am really thinking to return back to the old Win XP :(

Bartek Wilczynski (bartek) wrote :

Another confirmation. I've tried to install ubuntu on my macbook pro (penryn) and I cannot run linux: no bootable device...

Lacraia (lacraia-tellus) wrote :

I've got this error when I tried to install Kubuntu 8.04 KDE4 flavour on my MacBook Pro bought in July 2008. After running rEFIt's partioning tool I also had to reinstall GRUB.

bahonurn (bahonurn) wrote :

hmm i did install rEFIT so it settled the problem with black window with "No bootable device error..." but now the same problem the others have already faced: the penguin is still standing there looking at me and as though laughing at me

Ricky Campbell (cyberdork33) wrote :

Try completely powering down and starting up a few times. If it still doesn't get past the penguin, then you need to reinstall grub. Check the Apple Users forum for information.

bahonurn (bahonurn) wrote :

Original: Try completely powering down and starting up a few times. If it still doesn't get past the penguin, then you need to reinstall grub. Check the Apple Users forum for information.

Hey thanks very much it helped actullay i just rebooted three times so i am now insice ubuntu VIOLA!!!
i didn have to reinstall grub.
thanks everybody
the information here was very useful!

Ricky Campbell (cyberdork33) wrote :

This bug seems to still affect Intrepid.

Changed in ubiquity:
status: New → Confirmed
Nick (nbushak) wrote :

problem affected me. please fix!

Ricky Campbell (cyberdork33) wrote :

A ubuntuforums user seems to have narrowed this down to grub. The problem seems to appear when grub is installed.

Another affected used. Syncing partition tables with a refit rescue cd was able to rectify the problem. It occurred for me when I tried to install grub to /dev/sda and to (hd0).

Pete (pxw) wrote :
Download full text (4.0 KiB)

I did some tests to provide data about this bug - failure of intel mac MBR boot loaders to restart after ubuntu install.

Used:
Ubuntu parted partition editor in ubuntu 704 and 810.
MacBook2.1 with 80GB disk, assisted by a second external system and efi bootloader.

1. The /dev/sda sector0 and MBR was wiped to 00 leaving only the 55aa msdos MBR disk signature.

MBR here meaning = the 4x16byte partition entries above 446 bytes.

# dd if=/dev/zero of=/dev/sda bs=510 count=1
# hexdump -Cn512 /dev/sda
00000000 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 |................|
*
000001f0 00 00 00 00 00 00 00 00 00 00 00 00 00 00 55 aa |..............U.|
00000200

2. Then using the 704 live cd -

 # parted /dev/sda toggle 1 boot
 This was done twice, no net effect, but causing a write to the disk MBR.

 The MBR as 704 parted left it (there is a boot flag at 0x1ce on partition#2, unexplained).

00000000 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 |................|
*
000001b0 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 fe |................|
000001c0 ff ff ee fe ff ff 01 00 00 00 27 40 06 00 80 fe |..........'@....|
000001d0 ff ff af fe ff ff 28 40 06 00 30 a1 7e 02 00 fe |......(@..0.~...|
000001e0 ff ff af fe ff ff 58 e1 88 02 08 20 ae 00 00 fe |......X.... ....|
000001f0 ff ff 83 fe ff ff 60 01 37 03 de 0e e9 02 55 aa |......`.7.....U.|
00000200

 gptsync reports "Status: Tables are synchronized, no need to sync."

 Ubuntu 704 installation can then boot on restart using MBR loaders without using gptsync (boot sector code below MBR partition data appeared later).
 ===================

3. Wipe the MBR again to check 810 parted (from xububtu810 on external disk)

root@wdc:/home/pxw# hexdump -Cn512 /dev/sda
00000000 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 |................|
*
000001f0 00 00 00 00 00 00 00 00 00 00 00 00 00 00 55 aa |..............U.|
00000200

root@wdc:/home/pxw# gptsync /dev/sda
reports Current MBR partition table:
 No partitions defined

Status: MBR table must be updated.

Offers to update, Not done. just checking its valid for gptsync, but leave as is for test.

root@wdc:/home/pxw# parted
Then use 810 parted toggle operation to trigger write to disk.

This resets the sector0 mbr to one partition, full disk size, valid for gptsync,
and the same format found after initial partitioning by macosx10.4.8 diskutility.

root@wdc:/home/pxw# hexdump -Cn512 /dev/sda
00000000 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 |................|
*
000001c0 01 00 ee fe ff ff 01 00 00 00 af f8 50 09 00 00 |............P...|
000001d0 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 |................|
*
000001f0 00 00 00 00 00 00 00 00 00 00 00 00 00 00 55 aa |..............U.|
00000200
(disk size shown here in 512byte sectors is 0x950F8AF = 156301487 =whole disk)

This requires running gptsync from the ubuntu refit package to create full MBR partiton data to allow grub or windows loader to boot.

After running gptsync the MBR is updated ready for MBR booting.
root@wdc:/home/pxw# hexdump -Cn512 /dev/sda
(boot code appears before here)-----
000001b0 00 00 00 00 00 00 00 00 00 00 00 00 00 00 0...

Read more...

Pete (pxw) wrote :

The detailed tests in my previous post confirm that the 810 parted is not updating the MBR with the partition information needed by apple intel macs, resulting in the bug.

I repeat here my proposed solution, which was at the end.

Solution:

The refit package should be part of the installation, and a user option provided after partitioning to sync MBR for intel mac MBR loaders. (Not necessary for efi/gpt loaders).
This will improve the install/restart experience for intel apple mac users.
It will still be necessary to run gptsync after any re-partitioning.

But preferably revert to the previous partitioner version for apple intel macs, unless there are good reasons not to do so.

Greg Bell (eldorel) wrote :

Confirmed on my macbook pro with both hardy and intrepid.

Jonathan Simon (der-joni) wrote :

Confirmed on MacBook5,1.
Made a FAT32 partition using the BootCamp Assistant, when the "Insert Windows CD and click Button" message appeared, I clicked "Cancel." Then I installed Intrepid Ibex, shrinking the BootCamp partition, adding another FAT32 partition for data exchange, and adding the ext3 root partition and swap partition.

I didn't install rEFIt before installing Ubuntu, and I accidentally installed GRUB to the MBR (default installation). This way I ended up with no bootable system at all. I could start into Ubuntu by inserting the CD and hitting the "Start from first hard disk" option, but there was no way to get into OS X (tried different possibilities with the OS X installation disc).
Solution for me was to download the rEFIt ISO image in Ubuntu, and burning it to a CD. Then I was able to resync my partition tables and boot into any OS.

John Pugh (jpugh) wrote :

Has anyone tested with the latest Jaunty alphas?

I just tried with Intrepid and it worked out of the box, without partition table update

Ricky Campbell (cyberdork33) wrote :

Well, it definitely affects a lot of people in Intrepid still... It has a lot to do with how you install and what the state of your disk was before doing the install.

I am trying to check this on Jaunty.

mbp0392 (gusgl2001) wrote :

I had the same issue. couldn't boot windows or linux after installing ubuntu. I am triple booting. Using the sync feature of reFIT fixed it.

Colin Watson (cjwatson) wrote :

Ricky, could you please post the output of 'sudo dmidecode'? I have a good idea what this might be, but want to double-check.

Colin Watson (cjwatson) wrote :

(This isn't a bug in ubiquity as such; nor is it a bug in grub-installer. The parted task remains open.)

Changed in ubiquity (Ubuntu):
status: Confirmed → Invalid
Changed in grub-installer:
status: New → Invalid
Changed in parted (Ubuntu):
importance: Undecided → High
status: Confirmed → Triaged
assignee: nobody → cjwatson
Ricky Campbell (cyberdork33) wrote :

I will get this posted later for both an iMac5,1 and a MacBookPro4,1. If other users can post theirs sooner... go for it.

Ricky Campbell (cyberdork33) wrote :

ok here is dmidecode for my MacBookPro4,1

Colin Watson (cjwatson) wrote :

Perfect, that's just what I thought.

There are two causes for this bug. The first was that, in Hardy, I fixed bug 107326, which meant that GPT support was broken for everyone *not* on an Apple system. (That's the reason why simply reverting to an older version is not the answer here; I don't like toggling between bugs!) The second is that Apple changed their company name in early 2007 from "Apple Computer, Inc." to "Apple Inc.", and so all machines manufactured since then identify themselves with the new name rather than the old name. Most of the installer was updated some time back (see http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=483182) but we forgot about parted.

I'll get this fixed in Jaunty very shortly, and we should issue an update for at least Ubuntu 8.04.3 as well. (Intrepid is trickier since we have no plans to produce updated CD images, but I suppose parted is used on the installed system too.)

Changed in ubiquity (Ubuntu Hardy):
status: New → Invalid
Changed in ubiquity (Ubuntu Intrepid):
status: New → Invalid
Changed in parted (Ubuntu Hardy):
assignee: nobody → cjwatson
importance: Undecided → High
status: New → Triaged
milestone: none → ubuntu-8.04.3
Changed in parted (Ubuntu Intrepid):
assignee: nobody → cjwatson
importance: Undecided → High
status: New → Triaged
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package parted - 1.8.8.git.2008.03.24-11.1ubuntu6

---------------
parted (1.8.8.git.2008.03.24-11.1ubuntu6) jaunty; urgency=low

  * gptsync.dpatch (update):
    - Treat ext4 like ext3 for the purposes of the protective MBR.
    - Add "Apple Inc." as a possible Apple DMI vendor string (LP: #222126).

 -- Colin Watson <email address hidden> Sat, 28 Mar 2009 13:02:52 +0000

Changed in parted:
status: Triaged → Fix Released
Ricky Campbell (cyberdork33) wrote :

Thanks Colin!

Changed in mactel-support:
status: Confirmed → Fix Committed
Jan Claeys (janc) wrote :

For those people who don't know how to get their machine to boot again after this bug happened, I'll copy 2 lines from IRC here:

<pgraner> Press Option-Command-P-R until you hear two beeps, that will reset the NVRAM
<pgraner> then see if it will boot, there is enough efi code in the NVRAM that by resetting it you prob can boot by: Press C during startup with a CD in

It is also (in a bit more detail) explained here: http://support.apple.com/kb/HT1379

theOlster (oliver-thelortons) wrote :

I've just installed the Jaunty 9.04 Beta on my iMac, and I can confirm that the bug has been fixed.

Ricky Campbell (cyberdork33) wrote :

Good to know Jan. We noticed that more recently this issue would cause only a blinking question mark after reboot. We had generally been recommending the use of rEFIt (on a CD or USB drive) to sync the partition tables.

theOlster,
What tools did you use to partition before installing? We have noticed that sometimes this occurs, and other times it does not, especially if you are installing over a partition that already existed.

theOlster (oliver-thelortons) wrote :

I was installing over a partition that previously existed, but was re-formatted.

If you think it would be worth me removing the partition and starting again from scratch, then I might have some time this weekend. But I only want to do it if it is worth it!

On Apr 3, 2009, at 9:15 AM, theOlster wrote:
> If you think it would be worth me removing the partition and starting
> again from scratch, then I might have some time this weekend. But I
> only
> want to do it if it is worth it!

No, it seems to manifest itself when you actually do the partitioning,
especially, for the first time. So that means that you would have to
resize your OSX partition back to fill the space and start like new. I
don't think it is worth all that.

maybe it is only affecting those that don't already have a MBR table
defined (since it is not needed for a normal OSX installation).

Colin Watson (cjwatson) on 2009-06-04
description: updated
Colin Watson (cjwatson) wrote :
Ricky Campbell (cyberdork33) wrote :

It looks like this is fixed (or at least mostly fixed) in Jaunty. They haven't been complaints, and people that think the problem still exists have noted that the partition table was correct and didn't need fixed.

There may still be an issue when using the alternate installer rather than the normal desktop installer. We are going to have to get some more input on that.

Changed in mactel-support:
status: Fix Committed → Fix Released
Colin Watson (cjwatson) wrote :
description: updated
Martin Pitt (pitti) wrote :

Accepted parted into intrepid-proposed, the package will build now and be available in a few hours. Please test and give feedback here. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you in advance!

Changed in parted (Ubuntu Intrepid):
status: Triaged → Fix Committed
tags: added: verification-needed
Martin Pitt (pitti) wrote :

Accepted parted into hardy-proposed, the package will build now and be available in a few hours. Please test and give feedback here. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you in advance!

Changed in parted (Ubuntu Hardy):
status: Triaged → Fix Committed
Steve Beattie (sbeattie) on 2009-06-16
tags: added: hw-specific
talk2vz (talk2vz) wrote :

I installed ubuntu 9.04 on my unibody Macbook Pro 5.1 and after many attempts I've not been able to make it dual boot with OSX. So seems like this problem is not yet completely fixed in Jaunty. I installed refit, then installed ubuntu into boot camp partition. Installation went fine. But when I try to boot into ubuntu using refit, I get a blank screen with just GRUB (plain text) written on it. I shut down and restarted my machines many times. reinstalled grub too, but it does not work. I've OS X installed in sda2 partition, ubuntu installed in sda4 and have a HFS partition sda3 b/w the two for my data. Someone please help?

talk2vz (talk2vz) wrote :

continuing to my post above...in my first ubuntu installation, I accidentally installed grun on /dev/sda which did not work. In my later attempts, I've been installing grub on /dev/sda4 (ubuntu partition). So seems like I've grub installed in two places. Can that be causing this problem?

talk2vz (talk2vz) wrote :

Another thing...after ubuntu installation..refit partition tool did not complain about partition table syncing...it said everything was already in sync.

If refit said the partitions are in sync then that gives more evidence
that this bug is fixed. If you have other issues you should check the
apple users section of ubuntuforums.

Ricky

On Jun 27, 2009, at 2:03 AM, talk2vz <email address hidden> wrote:

> Another thing...after ubuntu installation..refit partition tool did
> not
> complain about partition table syncing...it said everything was
> already
> in sync.
>
> --
> Partition Table is cleared during install on Intel Macs
> https://bugs.launchpad.net/bugs/222126
> You received this bug notification because you are a direct subscriber
> of the bug.

Steve Langasek (vorlon) wrote :

Is anyone able to verify that this issue is resolved with the package in hardy-proposed? Daily test ISOs for the upcoming 8.04.3 point release are available at <http://cdimage.ubuntu.com/hardy/daily-live/current/>.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package parted - 1.7.1-5.1ubuntu9.2

---------------
parted (1.7.1-5.1ubuntu9.2) hardy-proposed; urgency=low

  * gptsync.dpatch (update): Add "Apple Inc." as a possible Apple DMI vendor
    string (LP: #222126).

 -- Colin Watson <email address hidden> Thu, 04 Jun 2009 17:22:24 +0100

Changed in parted (Ubuntu Hardy):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package parted - 1.8.8.git.2008.03.24-7ubuntu8

---------------
parted (1.8.8.git.2008.03.24-7ubuntu8) intrepid-proposed; urgency=low

  * gptsync.dpatch (update): Add "Apple Inc." as a possible Apple DMI vendor
    string (LP: #222126).

 -- Colin Watson <email address hidden> Thu, 04 Jun 2009 20:12:55 +0100

Changed in parted (Ubuntu Intrepid):
status: Fix Committed → Fix Released
Chris Langton (chrislangton84) wrote :

just installed precise (14.04 beta 2) on my new work iMac delivered today and after successful installation there were no boot devices or OS's.
I retried the installation completely for a second time, to ensure i followed the instruction carefully and correctly - the same result.

Perhaps this issue has been re-introduced in precise? or the fixed package is omitted or something?

It is very important that i use linux for my development work, and i am most comfortable with ubuntu gnome but i think i have no choice but to try Intrepid... mainly because this bug fix seems to only be working for that old release of ubuntu...

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.